summaryrefslogtreecommitdiffstats
path: root/src-wireless
diff options
context:
space:
mode:
authorJames Rayner <james@archlinux.org>2009-08-10 08:09:16 +0200
committerJames Rayner <james@archlinux.org>2009-08-10 08:09:16 +0200
commit9a3078d8cec470b3820c5597d5c8819d642e558d (patch)
tree7287f79ad908eb8cd6352b19c3e59e6bc57e4c94 /src-wireless
parent280b25e1171a4609356e888066614a4dc2ecb678 (diff)
downloadnetctl-9a3078d8cec470b3820c5597d5c8819d642e558d.tar.gz
netctl-9a3078d8cec470b3820c5597d5c8819d642e558d.tar.xz
revert pryor patch
Diffstat (limited to 'src-wireless')
-rw-r--r--src-wireless/net-auto43
-rw-r--r--src-wireless/netcfg-auto-wireless139
-rw-r--r--src-wireless/wireless-dbus146
3 files changed, 79 insertions, 249 deletions
diff --git a/src-wireless/net-auto b/src-wireless/net-auto
index 98bb91d..8b724a5 100644
--- a/src-wireless/net-auto
+++ b/src-wireless/net-auto
@@ -2,16 +2,12 @@
. /etc/rc.conf
. /etc/rc.d/functions
-. /usr/lib/network/globals
case "$1" in
start)
- if ! ck_daemon net-auto; then # JP: check if it's already running
- exit_stderr "net-auto has already been started: try \"/etc/rc.d/net-auto restart\""
- fi
# Ensure any device renaming has occurred as intended
for daemon in "${DAEMONS[@]}"; do
- if [[ "$daemon" = "${daemon#!}" && "$daemon" = net-rename ]]; then
+ if [ "$daemon" = "${daemon#!}" -a "$daemon" = "net-rename" ]; then
if ck_daemon net-rename; then
/etc/rc.d/net-rename start
fi
@@ -19,43 +15,28 @@ case "$1" in
done
# TODO: check if any way of using 'stacks' in bash
-
- rm -f "$STATE_DIR/net-auto"
- for iface in "${AUTO_NETWORKS[@]}"; do
- if [[ "${iface:0:4}" = auto ]]; then
- auto="$iface"
- elif [[ -n "$auto" ]]; then
- if /usr/bin/netcfg-"$auto" "$iface"; then
- echo "$iface" >> "$STATE_DIR/net-auto"
- add_daemon net-auto # JP: was this forgotten?
- fi
+ for iface in ${AUTO_NETWORKS[@]}; do
+ if [[ "${iface:0:4}" = "auto" ]]; then
+ auto=$iface
+ elif [[ "$auto" ]]; then
+ /usr/bin/netcfg-$auto $iface
+ [[ $? -eq 0 ]] && echo $iface >> /var/run/daemons/net-auto
unset auto
- else
- true # JP: can AUTO_NETWORKS contain elements other than ...auto-CONNECTION INTERFACE...?
- # JP: for example, what do we do with AUTO_NETWORKS=(auto-wireless wlan0 eth0)?
- # JP: or with AUTO_NETWORKS=(eth0 auto-wireless wlan0)?
fi
done
;;
stop)
- if ck_daemon net-auto; then
- exit_stderr "net-auto not running"
- fi
-
- for iface in $(cat "$STATE_DIR/net-auto"); do # JP: note that we may have written "wlan0 wlan1" to net-auto
- # e.g. if the user did AUTO_NETWORKS=(auto-wireless "wlan0 wlan1")
- # and now we're unpacking and handling wlan0, wlan1 one by one
- # that's not necessarily a problem...I'm just calling attention to it
- /usr/bin/netcfg iface-down "$iface"
+ [[ ! -e /var/run/daemons/net-auto ]] && exit 0
+ for iface in $(cat /var/run/daemons/net-auto); do
+ netcfg iface-down $iface
done
- rm -f "$STATE_DIR/net-auto"
rm_daemon net-auto
;;
restart)
- "$0" stop; sleep 1; "$0" start
+ $0 stop; sleep 1; $0 start
;;
*)
- exit_stderr "Usage: $0 {start|stop|restart}"
+ echo "usage: $0 {start|stop|restart}"
esac
# vim: set ts=4 et sw=4:
diff --git a/src-wireless/netcfg-auto-wireless b/src-wireless/netcfg-auto-wireless
index a17232c..e77eb0e 100644
--- a/src-wireless/netcfg-auto-wireless
+++ b/src-wireless/netcfg-auto-wireless
@@ -1,128 +1,59 @@
#! /bin/bash
# Originally contributed by Neuro: http://bbs.archlinux.org/viewtopic.php?pid=278148#p278148
+. /usr/lib/network/network
+. /usr/lib/network/wireless
. /etc/rc.conf
. /etc/rc.d/functions
-. /usr/lib/network/network
-. /usr/lib/network/wireless_utils
# wifi_auto
# autoconnect wireless interface
# $1 - wireless interface
wifi_auto()
{
- local interface="$1" connection="$2"
-
- if [[ ! -f "$CONN_DIR/$connection" ]]; then
- exit_err "$connection is not a valid connection."
- elif ! "$CONN_DIR/$connection" verify "$interface"; then
- exit_err "$interface is not a wireless interface."
- fi
-
- report_try "Scanning for networks"
+ interface=$1;
+ stat_busy "Scanning for networks"
- local status=$(query_iface "$interface" "$connection") # supply $connection as hint
- case "$status" in
- disabled)
- exit_fail "INTERFACE $interface is disabled."
- ;;
- external)
- exit_fail "INTERFACE $interface was configured by another application."
- ;;
- "")
- #ifconfig "$interface" up 2>/dev/null # $? is 255 when radio-switched-off
- "$CONN_DIR/$connection" control "$interface" up
- if [[ $? -gt 0 ]]; then
- # interface is really disabled
- "$CONN_DIR/$connection" control "$interface" disable
- exit_fail "INTERFACE $interface is disabled."
- fi
- ;;
- *)
- # interface already up and controlled by a profile
- ;;
- esac
+ ifconfig $interface up
+ networks="$(list_networks $interface)"
- networks=$(list_networks "$interface")
-
- if [[ -z "$networks" ]]; then
- # disconnect interface if it wasn't already up
- [[ -z "$status" ]] && "$CONN_DIR/$connection" control "$interface" forcedown
- exit_fail "No local networks."
+ if [[ ! "$networks" ]]; then
+ stat_append "- No networks available."
+ stat_fail
+ exit 1
fi
- [[ -z "$status" ]] && "$CONN_DIR/$connection" control "$interface" down # take iface down here so that query_iface doesn't perceive it as externally controlled
- # unclear what should happen if $status set to an already-connected profile...?
-
# Loop through all the found essid's, then find a matching profile.
-
- local found_profile found_essid
-
- # JP: add ability to use AP instead of ESSID
- # JP: also, make ESSIDs in wireless-dbus CONNECTIONS a regexp instead of a literal
- while read ap essid; do
- while read network; do
- (
- unset CONNECTION INTERFACE AP
- load_profile "$network"
- case "$CONNECTION" in
- wireless-old|wireless|wireless-dbus)
- if [[ "$interface" = "$INTERFACE" ]]; then
- if [[ "$ap" == "$AP" ]]; then
- exit 2
- elif [[ -z "$found_profile" ]]; then
- if [[ "$CONNECTION" == wireless-dbus ]]; then
- if expr match "$essid" "^$ESSID\$" 1>/dev/null; then
- exit 1
- fi
- elif [[ "$essid" == "$ESSID" ]]; then
- exit 1
- fi
- fi
- fi
- ;;
- esac
- exit 0
- )
- case $? in
- 2) found_profile="$network"
- found_essid="$essid"
- break 2;;
- 1) found_profile="$network"
- found_essid="$essid"
- ;;
- esac
- done < <(list_profiles) # avoid subshell
- done < "$networks" # avoid subshell; list_networks returns name of a tmp file
- # JP: now each line of that file is of format: ap essid...
+ while read essid; do
+ for network in $(list_profiles); do
+ load_profile $network
+ case "$CONNECTION" in
+ wireless-old|wireless|wireless-dbus)
+ if [[ "$essid" = "$ESSID" && "$interface" = "$INTERFACE" ]]; then
+ found=$network
+ fi
+ ;;
+ esac
+ done
+ done < $networks
- rm -f "$networks" # shouldn't we delete the tmp file?
-
- if [[ -n "$found_profile" ]]; then
- report_success
- if profile_up "$found_profile" "$found_essid"; then # we pass literal essid to profile_up as $2
- exit 0
- else
-
-
-
- "$CONN_DIR/$connection" control "$interface" forcedown # take down interface?
- exit_fail "Couldn't connect profile $found_profile."
- fi
- else
- [[ -z "$status" ]] && "$CONN_DIR/$connection" control "$interface" forcedown
- exit_fail "No profiles matched the local networks."
+ if [[ "$found" ]]; then
+ netcfg $found
+ exit $?
fi
+ stat_append "- No profiles matched the found networks"
+ stat_fail
+ exit 1
}
if [[ $(id -u) -ne 0 ]]; then
- exit_stderr "This script should be run as root."
+ err "This script needs to be run with root priviledges"
+ exit 1
fi
-if [[ -z "$1" ]]; then
- exit_stderr "Must supply an interface to connect."
+if [[ -z $1 ]]; then
+ err "Please supply an interface to connect"
+ exit 1
fi
-
-SELF=$(basename $0)
-wifi_auto "$1" "${SELF#netcfg-auto-}" # we assume this script is named netcfg-auto-CONNECTIONTYPE
-
+wifi_auto $1
+
diff --git a/src-wireless/wireless-dbus b/src-wireless/wireless-dbus
index f1c1cd8..6f53a6c 100644
--- a/src-wireless/wireless-dbus
+++ b/src-wireless/wireless-dbus
@@ -4,7 +4,7 @@ import dbus
import shlex
import subprocess
from signal import SIGTERM
-from os import kill,path
+from os import kill
from time import sleep
# dbus constants.
@@ -21,20 +21,16 @@ def read_config(config):
cfg = shlex.split(open(config, "r").read())
options = {}
for line in cfg:
- (var, delim, value) = line.partition('=')
- if delim:
- var = var.lstrip()
- if var[0] != '#':
- value = value.partition("#")[0].rstrip()
- if value[0] == value[-1] and value[0] in ('"',"'"):
- value=value[1:-1]
- options[var] = value
+ (var, delim, value) = line.partition('=')
+ if delim and var.lstrip()[0] != "#":
+ options[var] = value
return options
def wep_hex2dec(key):
if len(key) not in [10, 26]:
- fail("Profile error: invalid KEY.", report_type="err")
+ print "Bad key"
+ raise SyntaxError
x=0
new_key=[]
@@ -44,24 +40,14 @@ def wep_hex2dec(key):
return new_key
-# JP: connect to our hookable reporting functions in /usr/lib/network/globals
-
-def report(report_type, *args):
- report_handler.stdin.write('report_%s %s\n' % (report_type, ' '.join(map(repr,args))))
-
-def fail(msg=None, report_type="fail"):
+def fail(msg=None):
if msg:
- report(report_type, msg)
- try:
- pid = open("/var/run/wpa_supplicant.pid").read()
- except IOError:
- pass
- else:
- kill(int(pid),SIGTERM)
+ print " -", msg
+ kill(int(open("/var/run/wpa_supplicant.pid").read()),SIGTERM)
sys.exit(1)
-def start(profile, essid):
+def start(profile):
# TODO: Add check if it's even a wireless interface
# Interface up - probably redundant, should be 'ip' instead.
#try:
@@ -82,25 +68,22 @@ def start(profile, essid):
except KeyError:
args.append("-Dwext")
- security = profile.get('SECURITY','none')
- if security == "wpa-config":
+ if profile['SECURITY'] == "wpa-config":
try:
args.append("-c" + profile["WPA_CONF"])
except KeyError:
args.append("-c/etc/wpa_supplicant.conf")
- elif not security in ['wpa', 'wep', 'none']:
- fail("Profile error: invalid SECURITY.", report_type="err")
+ elif not profile['SECURITY'] in ['wpa', 'wep', 'none']:
+ fail("Invalid security chosen")
# Start wpa_supplicant
- report('debug', 'wireless_dbus', 'starting wpa_supplicant')
supplicant = subprocess.Popen(args,stderr=subprocess.STDOUT,stdout=subprocess.PIPE)
output = supplicant.communicate()[0]
if supplicant.returncode not in [255,0]:
- print >>sys.stderr, output # JP: print to stderr
- fail("Couldn't start wpa_supplicant.")
+ print output
+ fail("Could not start wpa_supplicant")
# Connect to wpa_supplicant
- report('debug', 'wireless_dbus', 'connecting to wpa_supplicant')
bus = dbus.SystemBus()
wpas_obj = bus.get_object(WPAS_DBUS_SERVICE, WPAS_DBUS_OPATH)
wpas = dbus.Interface(wpas_obj, WPAS_DBUS_INTERFACE)
@@ -121,26 +104,20 @@ def start(profile, essid):
iface = dbus.Interface(if_obj, WPAS_DBUS_INTERFACES_INTERFACE);
# Add and select the network. Networks already specified for wpa-config
- if security in ['wpa','wep','none']:
- report('debug', 'wireless_dbus', 'add and select network')
+ if profile['SECURITY'] in ['wpa','wep','none']:
path = iface.addNetwork()
net_obj = bus.get_object(WPAS_DBUS_SERVICE, path)
rnet = dbus.Interface(net_obj, WPAS_DBUS_NETWORKS_INTERFACE)
iface.selectNetwork(rnet)
- if not essid:
- essid = profile["ESSID"]
- if security == "wpa":
- opts = dbus.Dictionary({"ssid": dbus.ByteArray(essid),
+ if profile['SECURITY'] == "wpa":
+ opts = dbus.Dictionary({"ssid": dbus.ByteArray(profile['ESSID']),
"psk": dbus.String(profile['KEY'])},
signature="sv")
- report('debug', 'wireless_dbus', 'connect to network with security=wpa')
- # next line crashes with
- # dbus.exceptions.DBusException: fi.epitest.hostap.WPASupplicant.InvalidOptions: Did not receive correct message arguments
rnet.set(opts)
- elif security == "wep":
+ elif profile['SECURITY'] == "wep":
key=profile['KEY']
if key[:2] == "s:": # String key prefixed by "s:"
keydbus=key[2:]
@@ -150,17 +127,15 @@ def start(profile, essid):
for l in key:
keydbus+=chr(l)
- opts = dbus.Dictionary({"ssid": dbus.ByteArray(essid),
+ opts = dbus.Dictionary({"ssid": dbus.ByteArray(profile['ESSID']),
"key_mgmt": dbus.String("NONE"),
"wep_tx_keyidx": dbus.Int32(1),
"wep_key0": dbus.ByteArray(keydbus)},
signature="sv")
- report('debug', 'wireless_dbus', 'connect to network with security=wep')
rnet.set(opts)
- elif security == "none":
- opts = dbus.Dictionary({"ssid": dbus.ByteArray(essid)},
+ elif profile['SECURITY'] == "none":
+ opts = dbus.Dictionary({"ssid": dbus.ByteArray(profile['ESSID'])},
signature="sv")
- report('debug', 'wireless_dbus', 'connect to network with security=none')
rnet.set(opts)
# Determine timeout
@@ -179,81 +154,24 @@ def start(profile, essid):
break
if n == timeout:
- # fail("Association/Authentication failed:" + state)
- fail("Couldn't associate/authenticate with wireless network.")
+ fail("Association/Authentication failed:" + state)
# Run ethernet and get an ip.
try:
- subprocess.check_call([ETHERNET_IPROUTE, "up", sys.argv[2]])
+ subprocess.check_call(["/usr/lib/network/connections/ethernet-iproute", "up", sys.argv[2]])
except subprocess.CalledProcessError:
fail()
sys.exit(0)
def stop(profile):
- ret = subprocess.call([ETHERNET_IPROUTE, "down", sys.argv[2]])
+ subprocess.call(["/usr/lib/network/connections/ethernet", "down", sys.argv[2]])
kill(int(open("/var/run/wpa_supplicant.pid").read()),SIGTERM)
- sys.exit(ret)
-
-def query(interface,request):
- if request == 'profile' or request=='enabled':
- ret = subprocess.call([WIRELESS, "query", interface, request, "-iproute"]) # JP: left some of the new query functionality in the wireless file because it's so bash-heavy
- elif request=='associated':
- ret = subprocess.call([WIRELESS, "query", interface, request, "-iproute", sys.argv[5], sys.argv[6]]) # JP: left some of the new query functionality in the wireless file because it's so bash-heavy
- else:
- ret = subprocess.call([ETHERNET_IPROUTE, "query", interface, request]) # JP: for these requests, we can call the ethernet-iproute functions directly and save some process overhead
- sys.exit(ret)
-
-def control(interface,action):
- if action == 'enable' or action == 'disable':
- ret = subprocess.call([WIRELESS, "control", interface, action])
- else:
- ret = subprocess.call([ETHERNET_IPROUTE, "control", interface, action]) # JP: for these actions, we can call the ethernet-iproute functions directly and save some process overhead
- sys.exit(ret)
-
-def verify(interface):
- ret = subprocess.call([WIRELESS, "verify", interface])
- sys.exit(ret)
+ sys.exit(0)
if __name__ == "__main__":
-
- CONN_DIR = path.abspath(path.dirname(sys.argv[0]))
- ETHERNET_IPROUTE = path.join(CONN_DIR,"ethernet-iproute")
- WIRELESS = path.join(CONN_DIR,"wireless")
-
- if sys.argv[1] == "query":
- interface,request = sys.argv[2:4]
- query(interface,request)
-
- elif sys.argv[1] == "control":
- interface,action = sys.argv[2:4]
- control(interface,action)
-
- elif sys.argv[1] == "verify":
- interface = sys.argv[2]
- verify(interface)
-
- else:
- # setup bash report_* handler
- report_handler_script = 'source /etc/rc.conf; source /etc/rc.d/functions; source %s/../globals; while read cmd args; do eval $cmd "$args"; done' % (CONN_DIR,)
- report_handler = subprocess.Popen(report_handler_script, executable='/bin/bash', stdin=subprocess.PIPE, shell=True)
-
- try:
- profile_name = sys.argv[2]
- profile = read_config("/etc/network.d/"+profile_name)
-
- essid = sys.argv[3] if len(sys.argv)>3 else "" # JP: pass literal ESSID as an argument, so that we can have entry in profile be a regexp
-
- if 'INTERFACE' not in profile:
- fail("Profile error: no INTERFACE to configure.", report_type="err")
-
- if sys.argv[1] == "up":
- start(profile, essid)
- elif sys.argv[1] == "down":
- stop(profile)
-
-
- finally:
- report_handler.stdin.close()
- report_handler.wait()
-
-# vim: et ts=4
+ profile = read_config("/etc/network.d/"+sys.argv[2])
+
+ if sys.argv[1] == "up":
+ start(profile)
+ elif sys.argv[1] == "down":
+ stop(profile)